<?php

namespace App\Livewire\Studio\Catalog;

use App\Livewire\Forms\Studio\Catalog\BrandForm;
use App\Models\Brand as BrandModel;
use App\Traits\WithAuthorization;
use App\Traits\WithCloseModal;
use App\Traits\WithConfirmation;
use App\Traits\WithToast;
use App\Traits\WithUpdatedData;
use Flux\Flux;
use Livewire\Attributes\On;
use Livewire\Attributes\Title;
use Livewire\Component;

#[Title('Merek')]
class Brand extends Component
{
    use WithAuthorization, WithCloseModal, WithConfirmation, WithToast, WithUpdatedData;

    public BrandForm $form;

    public string $method = 'create';

    public string $modalTitle = '';

    #[On('modal:open')]
    public function openModal(string $method, string $modalTitle, ?string $id = null)
    {
        $this->resetValidation();
        $this->resetErrorBag();

        $this->method = $method;
        $this->modalTitle = $modalTitle;

        if ($id) {
            $this->form->setBrand(BrandModel::byHashOrFail($id));
        }
    }

    public function create()
    {
        $this->canOrAbort('create brand');

        $this->form->store();

        $this->dispatch('refreshDatatable');

        $this->toast('Merek berhasil ditambahkan.');

        Flux::modals()->close();
    }

    public function update()
    {
        $this->canOrAbort('update brand');

        $this->form->update();

        $this->dispatch('refreshDatatable');

        $this->toast('Merek berhasil diperbarui.');

        Flux::modals()->close();
    }

    public function delete(BrandModel $brand)
    {
        $this->form->brand = $brand;

        $this->form->delete();

        $this->dispatch('refreshDatatable');

        $this->toast('Merek berhasil dihapus.');

        Flux::modals()->close();
    }

    #[On('fn:sortOrder')]
    public function sortOrder(BrandModel $brand, string $direction)
    {
        $this->canOrAbort('update brand');

        $this->form->brand = $brand;

        $this->form->sortOrder($direction);

        $this->dispatch('refreshDatatable');
    }

    public function render()
    {
        return view('livewire.studio.catalog.brands', [
            'pageTitle' => 'Merek',
        ]);
    }
}
